unit frmSamplerU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, StdCtrls, StdActns, ActnList, Grids, ShellAPI,
  ComCtrls, ToolWin, ImgList, Buttons, frmInfoU, frmWavInfoU, bass, parseU,
  wavU;

type
  TfrmSampler = class(TForm)
    MainMenu1: TMainMenu;
    PanelLeft: TPanel;
    SplitterH: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    SplitterV: TSplitter;
    cbStyle: TComboBox;
    lbInstrument: TListBox;
    lbSample: TListBox;
    ActionList1: TActionList;
    Memo1: TMemo;
    Splitter1: TSplitter;
    sgClip: TStringGrid;
    cbBits: TComboBox;
    FileExit1: TFileExit;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    Cut1: TMenuItem;
    SelectAll1: TMenuItem;
    N2: TMenuItem;
    FileSaveAs1: TFileSaveAs;
    SaveAs1: TMenuItem;
    FileOpen1: TFileOpen;
    Open1: TMenuItem;
    List: TMemo;
    FileSave1: TAction;
    FileExport1: TFileSaveAs;
    Timer1: TTimer;
    PanelR: TPanel;
    sgData: TStringGrid;
    ControlPlay1: TAction;
    ControlBegin1: TAction;
    ControlEnd1: TAction;
    ImageList1: TImageList;
    FileInfo1: TAction;
    Panel3: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton10: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton13: TToolButton;
    SpeedButton1: TSpeedButton;
    Timer2: TTimer;
    ExporttoWAV1: TMenuItem;
    Save1: TMenuItem;
    New1: TMenuItem;
    Info1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Media1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Timer3: TTimer;
    FileNew1: TAction;
    ToolButton8: TToolButton;
    ToolButton14: TToolButton;
    EditCopy1: TAction;
    EditCut1: TAction;
    EditSelectAll1: TAction;
    EditDelete1: TAction;
    EditPaste1: TAction;
    TimerP: TTimer;
    sb1: TStatusBar;
    Label1: TLabel;
    EditRepaint1: TAction;
    N8: TMenuItem;
    Repaint1: TMenuItem;
    FileWaveInfo1: TAction;
    procedure FormCreate(Sender: TObject);
    procedure cbStyleChange(Sender: TObject);
    procedure lbInstrumentClick(Sender: TObject);
    procedure sgDataMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgDataMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgDataPaste(newX, newY: integer);
    procedure InfoToMemo(Filename: string);
    procedure sgDataDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure sgDataDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure cbBitsChange(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditDelete1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditSelectAll1Execute(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileExport1Accept(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lbSampleClick(Sender: TObject);
    procedure FileNew1Execute(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Autosave(Sender: TObject);
    procedure FileInfo1Execute(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure ControlBegin1Execute(Sender: TObject);
    procedure ControlEnd1Execute(Sender: TObject);
    function findLastCol(Sender: TObject): integer;
    procedure ControlPlay1Execute(Sender: TObject);
    procedure TimerPTimer(Sender: TObject);
    procedure SelectR(left, top, right, bottom: integer);
    procedure playSample(Filename: string);
    procedure playFile(Filename: string);
    procedure playOff();
    procedure FreeAll();
    procedure sb1Resize(Sender: TObject);
    procedure sgDataDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure lbInstrumentDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure EditRepaint1Execute(Sender: TObject);
    procedure lbSampleDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FileWaveInfo1Execute(Sender: TObject);
    procedure FileExport1BeforeExecute(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure WMDropFiles (var Msg: TMessage); message wm_DropFiles;
  public
    { Public declarations }
  end;

var
  frmSampler: TfrmSampler;
  sampleLen: integer = 75600; //     :)  

implementation

{$R *.dfm}

const
  maxCol = 16; //  - 
  col: array [1..maxCol] of TColor = ($90EE90,
$FFD700,
$AA99FF,
$7FFFD4,
$66AAFF,
$BCEE68,
$AABBFF,
$44FFAA,
$BC8F8F,
$8FBC8F,
$DD99FF,
$98FB98,
$FFE4C4,
$ADD8E6,
$FFFACD,
$FFC0CB); //    /

var
  lastX, lastY: integer; //  ,    
  SamplesPath: String; //   (,    )
  clip1: string = ''; //    
  drag: boolean = false;
  MustToOpen: string;
  playPos, endPos: integer;
  fileCh: HSTREAM; //       
  strm: array [0..255] of HSTREAM; //    

//  ,    eJay
//        : Dance, HipHop, ChillOut...
//       - Bass, Drum, Loop...
//      wav-

function isSms(s: string): boolean;
begin
  Result := AnsiLowerCase(ExtractFileExt(s)) = '.sms';
end;

//       
procedure DirList(Path: string; List: TStrings);
var
  sr: TSearchRec;
begin
  List.Clear;
  while (copy(Path, Length(Path), 1) = '\') do
    delete(Path, Length(Path), 1);
  if DirectoryExists(Path) then
    if FindFirst(Path + '\*.*', faAnyFile, sr) = 0 then
    begin
      repeat
        if (sr.Attr = faDirectory) and (sr.Name[Length(sr.Name)] <> '.') then
          List.Add(sr.Name);
      until (FindNext(sr) <> 0);
      FindClose(sr);
    end;
end;

//    *.wav   
procedure FileList(Path: string; List: TStrings);
var
  sr: TSearchRec;
begin
  List.Clear;
  while (copy(Path, Length(Path), 1) = '\') do
    delete(Path, Length(Path), 1);
  if DirectoryExists(Path) then
    if FindFirst(Path + '\*.wav', faAnyFile, sr) = 0 then
    begin
      repeat
        if (sr.Attr <> faDirectory) and (sr.Name[Length(sr.Name)] <> '.') then
          List.Add(copy(sr.Name, 1, Length(sr.Name) - 4) + dev + Path + '\' + sr.Name);
      until (FindNext(sr) <> 0);
      FindClose(sr);
    end;
end;

//       
procedure TfrmSampler.cbBitsChange(Sender: TObject);
begin
  case cbBits.ItemIndex of
     0: sampleLen := 75600; // Dance 140 bpm
     1: sampleLen := 84672; // ChillOut 125 bpm
     2: sampleLen := 117600; // HipHop 90 bpm
  end;
  TimerP.Interval := Round(sampleLen / 44.1);
end;

//    ,    
procedure TfrmSampler.cbStyleChange(Sender: TObject);
begin
  DirList(SamplesPath + cbStyle.Text, lbInstrument.Items);
  lbInstrument.ItemIndex := 0;
  lbInstrumentClick(Sender);
end;

//     
procedure TfrmSampler.ControlBegin1Execute(Sender: TObject);
begin
  if TimerP.Enabled then
    ControlPlay1Execute(Sender);
  SelectR(1, 1, 1, 1);
  sgData.TopRow := 1;
  sgData.LeftCol := 1;
end;

//     
function TfrmSampler.findLastCol(Sender: TObject): integer;
var
  x, y: integer;
  empty: boolean;
begin
  empty := true;
  x := sgData.ColCount + 1;
  while (x > 1) and empty do
  begin
    dec(x);
    for y := 1 to sgData.RowCount - 1 do
    if sgData.Cells[x, y] <> '' then
      empty := false;
  end;
  if x < 1 then
    x := 1;
  Result := x;
end;

//     
procedure TfrmSampler.ControlEnd1Execute(Sender: TObject);
var
  R: TGridRect;
begin
  if TimerP.Enabled then
    ControlPlay1Execute(Sender);
  R.Left := findLastCol(Sender);
  R.Right := R.Left;
  R.Top := 1;
  R.Bottom := 1;
  sgData.Selection := R;
  sgData.TopRow := 1;
  sgData.LeftCol := R.Left;
end;

//      ,
//   
procedure TfrmSampler.ControlPlay1Execute(Sender: TObject);
begin
  if TimerP.Enabled then
  begin
    TimerP.Enabled := false;
    FreeAll;
    ControlPlay1.Checked := false;
  end
    else
  begin
    playPos := sgData.Selection.Left - 1;
    endPos := Self.findLastCol(Sender);
    playOff;
    TimerPTimer(Sender);
    TimerP.Enabled := true;
    ControlPlay1.Checked := true;
  end;
end;

//     
procedure TfrmSampler.EditCopy1Execute(Sender: TObject);
var
  ix, iy, w, h: integer;
begin
  h := sgData.Selection.Bottom - sgData.Selection.Top + 1;
  w := sgData.Selection.Right - sgData.Selection.Left + 1;
  sgClip.ColCount := w;
  sgClip.RowCount := h;
  for ix := 1 to w do
    sgClip.Cols[ix].Clear;
  for iy := 1 to h do
    for ix := 1 to w do
      sgClip.Cells[ix, iy] := sgData.Cells[
        sgData.Selection.Left + ix - 1, sgData.Selection.Top + iy - 1];
end;

//  
procedure TfrmSampler.EditCut1Execute(Sender: TObject);
begin
  EditCopy1Execute(Sender);
  EditDelete1Execute(Sender);
end;


//   
procedure TfrmSampler.EditDelete1Execute(Sender: TObject);
var
  x, y: integer;
begin
   for y := sgData.Selection.Top to sgData.Selection.Bottom do
     for x := sgData.Selection.Left to sgData.Selection.Right do
       sgData.Cells[x, y] := '';
end;

//   ,    
procedure TfrmSampler.EditPaste1Execute(Sender: TObject);
begin
  sgDataPaste(sgData.Selection.Left, sgData.Selection.Top);
end;

//   
procedure TfrmSampler.EditSelectAll1Execute(Sender: TObject);
begin
  SelectR(1, 1, sgData.ColCount, sgData.RowCount);
end;

//    WAV-
procedure TfrmSampler.FileExport1Accept(Sender: TObject);
var
  p, len, lc, x, y, i, bigLen: integer;
  s: string;
  strm: HSTREAM;
  BigWave, Wave: TWave;
  data, smp: TIntArray;
  F: TFileStream;
begin
  SetLength(smp, 1);
  lc := findLastCol(Sender);
  bigLen := 0;
  for x := 1 to lc do
  for y := 1 to sgData.RowCount do
  begin
    s := SamplesPath + getPart((sgData.Cells[x, y]), 1);
    strm := BASS_StreamCreateFile(False, PChar(s), 0, 0,
      0 {$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
    len := BASS_ChannelGetLength(strm, BASS_POS_BYTE);
    BASS_StreamFree(strm);
    p := x * sampleLen;
    if p + len > bigLen then
      bigLen := p + len;
  end;
  CreateWave(bigWave, bigLen);
  bigLen := bigLen div 2;
  SetLength(data, bigLen);
  for i := 0 to bigLen - 1 do
    data[i] := 0;
  for x := 1 to lc do
  begin
    for y := 1 to sgData.RowCount do
    begin
      s := SamplesPath + getPart((sgData.Cells[x, y]), 1);
      if FileExists(s) then
      begin
        p := (x - 1) * sampleLen; // sampleLen  16 
        ReadWave(s, Wave);
        len := Wave.DataHeader.DataLen;
        F := TFileStream.Create(s, fmOpenRead + fmShareDenyNone);
        F.Seek(Wave.DataSeek, 0);
        len := (len div 2) - 1;
        for i := 0 to len do
        begin
          F.Read(smp[0], 2);
          data[(p + i) div 2] := mix(smp[0], data[(p + i) div 2]);
        end;
      end;
    end;
    sgData.LeftCol := x;
  end;
  try
    F := TFileStream.Create(FileExport1.Dialog.FileName,
      fmCreate or fmOpenWrite or fmShareDenyNone);
    F.Write(bigWave.Header, SizeOf(TWaveHeader));
    F.Write(bigWave.DataHeader, SizeOf(TDataHeader));
    F.Write(Pointer(data[0]), bigLen * 2);
    F.Free;
  except
  end;
  SetLength(data, 0);
  SetLength(smp, 0);
  ControlBegin1Execute(Sender);
end;

procedure TfrmSampler.FileExport1BeforeExecute(Sender: TObject);
begin
  FileExport1.Dialog.FileName := FileSaveAs1.Dialog.FileName;
end;

//      
procedure TfrmSampler.FileInfo1Execute(Sender: TObject);
begin
  frmInfo.Show;
end;

//        
procedure TfrmSampler.FileNew1Execute(Sender: TObject);
begin
  if MessageDlg('Do you really want to erase current composition?',
    mtWarning, [mbYes, mbNo], 0) = mrYes then
  begin
    Timer2.Enabled := false;
    Autosave(Sender);
    EditSelectAll1Execute(Sender);
    EditDelete1Execute(Sender);
    SelectR(1, 1, 1, 1);
    sgData.TopRow := 1;
    sgData.LeftCol := 1;
    Timer2.Enabled := true;
  end;
end;

//   
procedure TfrmSampler.FileOpen1Accept(Sender: TObject);
var
  x, y, i: integer;
  s: string;
begin
  if TimerP.Enabled then
    ControlPlay1Execute(Sender);
  ControlBegin1Execute(Sender);
  List.Lines.Clear;
  List.Lines.LoadFromFile(FileOpen1.Dialog.FileName);
  Self.Caption := 'Simple Music Sampler: ' +
    ExtractFileName(FileOpen1.Dialog.FileName);
  if List.Lines.Count > 0 then
  begin
    s := AnsiLowerCase(List.Lines[0]);
    for i := 0 to cbBits.Items.Count - 1 do
      if AnsiLowerCase(cbBits.Items[i]) = s then
        cbBits.ItemIndex := i;
    s := AnsiLowerCase(parse(cbBits.Items[cbBits.ItemIndex], ' - ', 0));
    for i := 0 to cbStyle.Items.Count - 1 do
      if AnsiLowerCase(cbStyle.Items[i]) = s then
        cbStyle.ItemIndex := i;
    cbBitsChange(Sender);
    cbStyleChange(Sender);
  end;
  i := 1;
  for y := 1 to sgData.RowCount do
  for x := 1 to sgData.ColCount do
  begin
    if i < List.Lines.Count then
      sgData.Cells[x, y] := List.Lines[i];
    inc(i);
  end;
  frmInfo.Memo1.Lines.Clear;
  while (i < List.Lines.Count) do
  begin
    frmInfo.Memo1.Lines.Add(List.Lines[i]);
    inc(i);
  end;
  List.Lines.Clear;
end;

//      
procedure TfrmSampler.FileSaveAs1Accept(Sender: TObject);
var
  x, y: integer;
begin
  List.Lines.Clear;
  List.Lines.Add(cbBits.Items[cbBits.ItemIndex]);
  for y := 1 to sgData.RowCount do
  for x := 1 to sgData.ColCount do
    List.Lines.Add(sgData.Cells[x, y]);
  List.Lines.AddStrings(frmInfo.Memo1.Lines);
  List.Lines.SaveToFile(FileSaveAs1.Dialog.FileName);
  List.Lines.Clear;
  Self.Caption := 'Simple Music Sampler: ' +
    ExtractFileName(FileSaveAs1.Dialog.FileName);
end;

procedure TfrmSampler.FileWaveInfo1Execute(Sender: TObject);
begin
  frmWavInfo.Show;
end;

//  
procedure TfrmSampler.EditRepaint1Execute(Sender: TObject);
var
  i, x, y: integer;
  s, title, filename: string;
begin
  for y := 1 to sgData.ColCount do
    for x := 1 to sgData.RowCount do
    begin
      s := sgData.Cells[x, y];
      if s <> '' then
      begin
        title := getLeft(s);
        filename := getPart(s, 1);
        s := parse(filename, '\', 1);
        for i := 0 to lbInstrument.Items.Count - 1 do
        if (lbInstrument.Items[i] = s) then
          sgData.Cells[x, y] := title + dev + filename + dev + IntToStr(i);
      end;
    end;
end;

// 
procedure TfrmSampler.Autosave(Sender: TObject);
var
  s: string;
begin
  s := FileSaveAs1.Dialog.FileName;
  FileSaveAs1.Dialog.FileName := SamplesPath + '~autosave.sms';
  FileSave1Execute(Sender);
  FileSaveAs1.Dialog.FileName := s;
end;

//   
procedure TfrmSampler.FreeAll();
var
  i: integer;
begin
  for i := 0 to 255 do
  	BASS_StreamFree(strm[i]);
end;

//   
procedure TfrmSampler.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Autosave(Sender);
  FreeAll;
  BASS_Free;
end;

//   
procedure TfrmSampler.Timer3Timer(Sender: TObject);
begin
  Timer3.Enabled := false;
  if isSms(MustToOpen) and FileExists(MustToOpen) then
  //  
  if (MustToOpen = SamplesPath + '~autosave.sms') then
  begin
    FileOpen1.Dialog.FileName := MustToOpen;
    FileOpen1Accept(Sender);
    FileOpen1.Dialog.FileName := '';
  end
    else
  //      
  begin
    FileOpen1.Dialog.FileName := MustToOpen;
    FileSaveAs1.Dialog.FileName := MustToOpen;
    FileOpen1Accept(Sender);
  end;
end;

//  
procedure TfrmSampler.SelectR(left, top, right, bottom: integer);
var
  R: TGridRect;
begin
  R.Left := left;
  R.Right := right;
  R.Top := top;
  R.Bottom := bottom;
  sgData.Selection := R;
end;

//   ,    
procedure TfrmSampler.playSample(Filename: string);
var
  i: integer;
  empty: boolean;
begin
  empty := false;
  i := -1;
  while (not empty) and (i < 255) do
  begin
    inc(i);
    if BASS_ChannelIsActive(strm[i]) = 0 then
      empty := true;
  end;
  if empty then
  begin
    BASS_StreamFree(strm[i]);
    strm[i] := BASS_StreamCreateFile(False, PChar(Filename), 0, 0, 0 {$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
    BASS_ChannelPlay(strm[i], True);
  end;
end;

procedure TfrmSampler.sb1Resize(Sender: TObject);
begin

end;

//  
procedure TfrmSampler.TimerPTimer(Sender: TObject);
var
  i: integer;
begin
  inc(playPos);
  if playPos > endPos then
    TimerP.Enabled := false
  else
    begin
      SelectR(playPos, 1, playPos, sgData.RowCount);
      sgData.LeftCol := playPos;
      for i := 1 to sgData.RowCount do
      if sgData.Cells[playPos, i] <> '' then
        playSample(getPart(sgData.Cells[playPos, i], 1));
    end;
end;

procedure TfrmSampler.FormCreate(Sender: TObject);
var
  i: integer;
  s: string;
begin
  //   
  SamplesPath := ExtractFileDir(Application.ExeName) + '\';
  //     
  DirList(SamplesPath, cbStyle.Items);
  cbStyle.ItemIndex := 0;
  //    
  cbStyleChange(Sender);
  //   
  for i := 1 to 201 do
  begin
    s := IntToStr(i);
    while (Length(s) < 3) do
      s := '0' + s;
    sgData.Cells[i, 0] := s;
  end;
  for i := 1 to 33 do
  begin
    s := IntToStr(i);
    while (Length(s) < 2) do
      s := '0' + s;
    sgData.Cells[0, i] := 'Row: ' + s;
  end;
  //      sms,   
  if ParamCount > 0 then
    if isSms(ParamStr(1)) then
      MustToOpen := ParamStr(1);
  //   
  if MustToOpen = '' then
    MustToOpen := SamplesPath + '~autosave.sms';
  DragAcceptFiles(Handle, True); //   
  //   bass.dll
  if not BASS_Init(-1, 44100, 0, Handle, nil) then
    Close;
  Timer3.Enabled := true; //  ,   
end;

//   sms  
procedure TfrmSampler.WMDropFiles(var Msg: TMessage);
var
  fn: array[0..256] of char;
begin
  DragQueryFile(THandle(Msg.WParam), 0, fn, SizeOf(fn));
  if isSms(fn) then
  begin
    FileOpen1.Dialog.FileName := fn;
    Timer1.Enabled := true;
  end;
  DragFinish(THandle(Msg.WParam));
end;

//   ,     
procedure TfrmSampler.lbInstrumentClick(Sender: TObject);
begin
  if lbInstrument.Items.Count > 0 then
  begin
    FileList(SamplesPath + cbStyle.Text + '\' +
      lbInstrument.Items.Strings[lbInstrument.ItemIndex], lbSample.Items);
    lbSample.Color := col[(lbInstrument.ItemIndex mod maxCol) + 1];
  end;
end;

//   
procedure TfrmSampler.lbInstrumentDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with lbInstrument.Canvas do
  begin
    Brush.Color := col[(Index mod maxCol) + 1];
    FillRect(Rect);
    TextOut(Rect.Left + 2, Rect.Top, lbInstrument.Items[Index]);
  end;
end;

//      
procedure TfrmSampler.lbSampleClick(Sender: TObject);
var
  fn: string;
begin
  if lbSample.ItemIndex >= 0 then
  begin
    fn := getPart(lbSample.Items[lbSample.ItemIndex], 1);
    InfoToMemo(fn);
    playFile(fn);
  end;
end;

//    ,  
procedure TfrmSampler.lbSampleDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with lbSample.Canvas do
  begin
    If odSelected in State then
      Brush.Color := clHighLight
    else
      Brush.Color := lbSample.Color;
    FillRect(Rect);
    TextOut(Rect.Left + 2, Rect.Top, getLeft(lbSample.Items[Index]));
  end;
end;

//   
procedure TfrmSampler.FileSave1Execute(Sender: TObject);
begin
  if FileSaveAs1.Dialog.FileName = '' then
    FileSaveAs1.Execute
  else
    FileSaveAs1Accept(Sender);
end;

//     
// (    )
procedure TfrmSampler.sgDataDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  g:TGridCoord;
  s, title, filename: string;
begin
  g := sgData.MouseCoord(X, Y);
  if (g.X > 0)and(g.Y > 0)and(lbSample.ItemIndex >= 0) then
  begin
    s := lbSample.Items.Strings[lbSample.ItemIndex];
    title := getPart(s, 0);
    filename := getPart(s, 1);
    delete(filename, 1, Length(SamplesPath));
    sgData.Cells[g.X, g.Y] := title + dev + filename + dev +
      IntToStr(lbInstrument.ItemIndex);
  end;
end;

// ,      
procedure TfrmSampler.sgDataDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  //  !
end;

//  
procedure TfrmSampler.sgDataDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  s: string;
  i: integer;
begin
  s := getPart(sgData.Cells[Acol, ARow], 2);
  i := StrToIntDef(s, -1);
  if (i >= 0) then
  with sgData.Canvas do
  begin
    Brush.Color := col[(i mod maxCol) + 1];
    FillRect(Rect);
    TextOut(Rect.Left + 2, Rect.Top + 2, getLeft(sgData.Cells[ACol, ARow]));
  end;
end;

//       
procedure TfrmSampler.sgDataPaste(newX, newY: integer);
var
  ix, iy, w, h: integer;
begin
  h := sgClip.RowCount;
  w := sgClip.ColCount;
  for iy := 1 to h do
    for ix := 1 to w do
      if sgClip.Cells[ix, iy] <> '' then
        sgData.Cells[newX + ix - 1, newY + iy - 1] := sgClip.Cells[ix, iy];
  SelectR(newX, newY, newX + w - 1, newY + h - 1);
end;

//       Sender
procedure TfrmSampler.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  FileOpen1Accept(Sender);
end;

//   60 
procedure TfrmSampler.Timer2Timer(Sender: TObject);
begin
  Autosave(Sender);
end;

//    ...
procedure TfrmSampler.sgDataMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  g: TGridCoord;
begin
  //     
  g := sgData.MouseCoord(X, Y);
  //      ...
  if (g.X > 0)and(g.Y > 0) then
  begin
    //      
    // ( ?)
    lastX := g.X;
    lastY := g.Y;
    //     ,     
    if (Button = mbRight) then
    begin
      if sgData.Cells[g.X, g.Y] <> '' then
        drag := true;
      if (g.X >= sgData.Selection.Left)and(g.Y >= sgData.Selection.Top)
        and(g.X <= sgData.Selection.Right)and(g.Y <= sgData.Selection.Bottom) then
      begin
        EditCopy1Execute(Sender);
        clip1 := '';
      end
        else
      clip1 := sgData.Cells[g.X, g.Y];
    end;
  end;
end;

//    ...
procedure TfrmSampler.sgDataMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  g: TGridCoord;
begin
  //     
  g := sgData.MouseCoord(X, Y);
  //      ...
  if (g.X > 0)and(g.Y > 0) then
  begin
    if (Button = mbLeft) then
      InfoToMemo(getPart(sgData.Cells[g.X, g.Y], 1));
    //     -  
    if (Button = mbLeft)and(lastX = g.X)and(lastY = g.Y) then
      playFile(SamplesPath + getPart(sgData.Cells[g.X, g.Y], 1));
    //       
    if (Button = mbLeft)and(sgData.Cells[g.X, g.Y] = '') then
      playOff;
    //     
    //     
    if (Button = mbRight)and drag then
    begin
      drag := false;
      //   ,   ,  
      if (Shift = [ssShift]) then
      begin
        if clip1 = '' then
          EditDelete1Execute(Sender)
        else
          sgData.Cells[lastX, lastY] := '';
      end;
      if clip1 = '' then
        sgDataPaste(g.X, g.Y)
      else
        sgData.Cells[g.X, g.Y] := clip1;
    end;
  end
    else
  //     ,   
  if drag and (Button = mbRight) then
  if clip1 = '' then
    EditDelete1Execute(Sender)
  else
    sgData.Cells[lastX, lastY] := '';
  if (not drag)and(g.X = 0)and(g.Y = 0) then
    EditSelectAll1Execute(Sender);
  drag := false;
end;

//  Memo   
procedure TfrmSampler.InfoToMemo(Filename: string);
var
  fn: string;
  len: int64;
  sec, cells: double;
begin
  if Filename <> '' then
  try
    frmWavInfoU.infoFN := Filename;
    BASS_StreamFree(fileCh);
    fileCh := BASS_StreamCreateFile(False, PChar(Filename), 0, 0,
      0 {$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
    fn := ExtractFilename(Filename);
    fn := copy(fn, 1, Length(fn) - 4);
    len := BASS_ChannelGetLength(fileCh, BASS_POS_BYTE); // the length in bytes
    sec := BASS_ChannelBytes2Seconds(fileCh, len); // the length in seconds
    cells := len / sampleLen;
    BASS_StreamFree(fileCh);
    Memo1.Lines.Clear;
    Memo1.Lines.Add(fn);
    Memo1.Lines.Add(Format('Length: %5.3f sec', [sec]));
    Memo1.Lines.Add(Format('Length: %5.1f cells', [cells]));
  except
  end;
end;

//   
procedure TfrmSampler.playFile(Filename: string);
begin
  BASS_StreamFree(fileCh);
  fileCh := BASS_StreamCreateFile(False, PChar(Filename), 0, 0,
    0 {$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
  BASS_ChannelPlay(fileCh, True);
end;

//   
procedure TfrmSampler.playOff();
begin
  BASS_StreamFree(fileCh);
end;

//uses FileCtrl; {Win only!}
//  SelectDirectory ('Choose Styles Folder', '', dir, [sdNewFolder, sdNewUI]);

end.
