unit frmWavInfoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, wavU;

type
  TfrmWavInfo = class(TForm)
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmWavInfo: TfrmWavInfo;
  infoFN: string;

implementation

{$R *.dfm}

procedure TfrmWavInfo.FormShow(Sender: TObject);
var
  Wave: TWave;
begin
  Memo1.Lines.Clear;
  if FileExists(infoFN) then
  try
    ReadWave(infoFN, Wave);
    with Wave.Header do
    begin
      Memo1.Lines.Add('idRiff: ' + idRiff);
      Memo1.Lines.Add('RiffLen: ' + IntToStr(RiffLen));
      Memo1.Lines.Add('idWave: ' + idWave);
      Memo1.Lines.Add('idFmt:  ' + idFmt);
      Memo1.Lines.Add('InfoLen: ' + IntToStr(InfoLen));
      Memo1.Lines.Add('WaveType: ' + IntToStr(WaveType));
      Memo1.Lines.Add('Channels: ' + IntToStr(Channels));
      Memo1.Lines.Add('SamplesPerSec: ' + IntToStr(SamplesPerSec));
      Memo1.Lines.Add('BytesPerSecond: ' + IntToStr(BytesPerSecond));
      Memo1.Lines.Add('BytesPerSample: ' + IntToStr(BytesPerSample));
      Memo1.Lines.Add('BitsPerSample: ' + IntToStr(BitsPerSample));
    end;
    Memo1.Lines.Add('idData: ' + Wave.DataHeader.idData);
    Memo1.Lines.Add('DataLen: ' + IntToStr(Wave.DataHeader.DataLen));
    Memo1.Lines.Add('');
    Memo1.Lines.Add('File size: ' + IntToStr(Wave.Filesize));
    Memo1.Lines.Add(Format('Length: %5.3f sec', [Wave.LengthSec]));
  except
    raise Exception.Create('Problems with file reading');
  end;
end;

end.
